#ifndef DX_BITTREX__DELTIX__QSRV__HF__PLUGINS__DATA__BITTREX__TYPES_DX_BITTREXTRADEENTRY_INC
#define DX_BITTREX__DELTIX__QSRV__HF__PLUGINS__DATA__BITTREX__TYPES_DX_BITTREXTRADEENTRY_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "Dx_TradeEntry.h"

using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::qsrv::hf::plugins::data::bittrex::types {

class Dx_BittrexTradeEntry : public dx_BITTREX::deltix::timebase::api::messages::universal::Dx_TradeEntry {
private:
    std::string __class_type__ = "deltix.qsrv.hf.plugins.data.bittrex.types.BittrexTradeEntry";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_17";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        Dx_TradeEntry::decode(reader);
        fillType_ = reader.readEnum8();
        total_ = Decimal64::fromUnderlying((uint64_t) reader.readInt64());
    }

    virtual void encode(DataWriter &writer) {
        Dx_TradeEntry::encode(writer);
        writer.writeEnum8(fillType_);
        writer.writeUInt64(total_.toUnderlying());
    }

    inline void clear() {
        Dx_TradeEntry::clear();
        fillType_ = DxApi::ENUM_NULL;
        total_ = D64_NULL;
    }

    inline void setFillType(int value) {
        this->fillType_ = value;
    }

    inline void setTotal(Decimal64 value) {
        this->total_ = value;
    }

    virtual string toString() {
        stringstream ss;
        ss << Dx_TradeEntry::toString() << ", ";
        ss << "  fillType_: "; 
        if (fillType_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << fillType_; }
        ss << ", ";
        ss << "  total_: "; 
        if (total_ == D64_NULL) { ss << "[NULL]"; } else { ss << total_; }
        return ss.str();
    };

    int fillType_;
    Decimal64 total_;

};

} // namespace dx_BITTREX::deltix::qsrv::hf::plugins::data::bittrex::types

#endif /* DX_BITTREX__DELTIX__QSRV__HF__PLUGINS__DATA__BITTREX__TYPES_DX_BITTREXTRADEENTRY_INC */
