#ifndef DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_L1ENTRY_INC
#define DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_L1ENTRY_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "Dx_BasePriceEntry.h"

using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::timebase::api::messages::universal {

class Dx_L1Entry : public Dx_BasePriceEntry {
private:
    std::string __class_type__ = "deltix.timebase.api.messages.universal.L1Entry";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_1b";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        Dx_BasePriceEntry::decode(reader);
        isNational_ = reader.readNullableBooleanInt8();
        side_ = reader.readEnum8();
    }

    virtual void encode(DataWriter &writer) {
        Dx_BasePriceEntry::encode(writer);
        writer.writeNullableBoolean(isNational_, isNational_ == Constants::BOOL_NULL);
        writer.writeEnum8(side_);
    }

    inline void clear() {
        Dx_BasePriceEntry::clear();
        isNational_ = Constants::BOOL_NULL;
        side_ = DxApi::ENUM_NULL;
    }

    inline void setIsNational(uint8_t value) {
        this->isNational_ = value;
    }

    inline void setSide(int value) {
        this->side_ = value;
    }

    virtual string toString() {
        stringstream ss;
        ss << Dx_BasePriceEntry::toString() << ", ";
        ss << "  isNational_: "; 
        if (isNational_ == Constants::BOOL_NULL) { ss << "[NULL]"; } else { ss << (int) isNational_; }
        ss << ", ";
        ss << "  side_: "; 
        if (side_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << side_; }
        return ss.str();
    };

    uint8_t isNational_;
    int side_;

};

} // namespace dx_BITTREX::deltix::timebase::api::messages::universal

#endif /* DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_L1ENTRY_INC */
