#ifndef DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_PACKAGEHEADER_INC
#define DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_PACKAGEHEADER_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "Dx_MarketMessage.h"

using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::timebase::api::messages::universal {

class Dx_PackageHeader : public dx_BITTREX::deltix::timebase::api::messages::Dx_MarketMessage {
private:
    std::string __class_type__ = "deltix.timebase.api.messages.universal.PackageHeader";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_1e";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        Dx_MarketMessage::decode(reader);
        packageType_ = reader.readEnum8();
    }

    virtual void encode(DataWriter &writer) {
        Dx_MarketMessage::encode(writer);
        writer.writeEnum8(packageType_);
    }

    inline void clear() {
        Dx_MarketMessage::clear();
        packageType_ = DxApi::ENUM_NULL;
    }

    inline void setPackageType(int value) {
        this->packageType_ = value;
    }

    virtual string toString() {
        stringstream ss;
        ss << Dx_MarketMessage::toString() << ", ";
        ss << "  packageType_: "; 
        if (packageType_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << packageType_; }
        return ss.str();
    };

    int packageType_;

};

} // namespace dx_BITTREX::deltix::timebase::api::messages::universal

#endif /* DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_PACKAGEHEADER_INC */
