import sys, os, struct

# Note: install dxapi from pip nexus repository 
#       pip install --extra-index-url https://nexus.deltixhub.com/repository/epm-rtc-public-python/simple
# or local directory from QuantServer installation:
#       pip install /path/to/QuantServer/python
#    or pip install .. (from current directory)

import dxapi

# Timebase URL specification, pattern is "dxtick://<host>:<port>"
timebase = 'dxtick://localhost:8011'

try:
    # Create timebase connection
    db = dxapi.TickDb.createFromUrl(timebase)

    # Open in read-only mode
    db.open(True)
    print('Connected to ' + timebase)

    # Get streams
    streams = db.listStreams()

    for stream in streams:
        options = stream.options()
        print(stream.key())
        print('   Name: ' + str(options.name()))
        print('   Scope: ' + str(options.scope))
        print('   DF: ' + str(options.distributionFactor))
        print('   Description: ' + str(options.description()))
finally:
    # database connection should be closed anyway
    if (db.isOpen()):
        db.close()
    print("Connection " + timebase + " closed.")
